      program area_mandelbrot
      implicit none
c
      integer i, j, numinside, npoints, maxiter
      integer*4 iseed
      parameter (npoints = 1000, maxiter = 10000)
      real ran
      real*8 r1, r2, area, error
      complex*16 c(npoints), z
c
c 1) Generate npoints random points in the complex plane.
c
      iseed = 54321
      r1=ran(iseed)
      do i=1,npoints
         r1=ran(iseed)
         r2=ran(iseed)
         c(i)=cmplx(-2.0+2.5*r1,1.125*r2)
      end do


c
c 2) Calculate area of mandelbrot set by monte carlo sampling :
c
c    2a) Outer loop runs over npoints, initialize z=c
c
c    2b) Inner loop has the iteration z=z*z+c, and threshold test
c

c
c 3) Output results
c
      area = 2.0*2.5*1.125 * real(numinside)/real(npoints)
      error = area/sqrt(real(npoints))
      print *, "Area of Mandelbrot set = ",area," +/- ",error
c
      stop
      end
