program gold
  implicit none
  integer :: i
  integer, parameter :: n=4000
  integer :: numpairs(n)
  logical :: conject
!
! 1) Initialise numpairs to 0, the array which will contain the
!    data for the number of Goldbach pairs for the first n even
!    numbers
!




!
! 2) Create a do loop for i = 1, n and call subroutine "goldbach" for
!    each iteration with the arguments 2*i and numpairs(i). This is the
!    loop to parallise.
!


!
! 3) Test to see if the conjecture is true, ie that there is at least
!    one Goldbach pair for each even number.
!

!
! 4) Output selected results
!
  do i=1,n,n/10
     print *, 2*i, numpairs(i)
  end do
!
  stop
end program gold

!
! External subroutines and functions. 
!

subroutine goldbach(evenno,numpairs)
!
  implicit none
  integer :: evenno,numpairs,j
  logical :: isprime
!
  numpairs = 0
  do j=2,evenno/2
     if (isprime(j).and.isprime(evenno-j)) numpairs = numpairs + 1
  end do
!
  return
end subroutine goldbach
!
!
!
logical function isprime(num)
!
  implicit none
  integer :: num,i
!
!
! CRUDE PRIMALITY TEST: CHECKS ALL INTEGERS LESS THAN SQUARE ROOT
! OF NUMBER
!
  if (num == 1) then 
     isprime = .false. 
     return
  endif
  isprime = .true.
  i=2
  do while ( (i<=(int(sqrt(real(num)))) ) .and. isprime)
     isprime = mod(num,i)/=0
     i=i+1
  end do
!
end function isprime

